Java try-catch、throw和throws的几点想法

以前写代码,很少用到异常,后来发现这种习惯是错的。异常也是一种信息,并不是错误。

1:先写个简单的类:

package com.exception.demo;

public class Main {
    public static void main(String[] args) {
        Main main = new Main();
    }

    public void methodTry() {

    }

    public void methodThrow() {

    }
}

初始环境就是这么简答。

2:下面给方法methodTry加上方法主体:

    public static void main(String[] args) {
        Main main = new Main();
        main.methodTry();
    }

    public void methodTry() {
        int a=10;
        int b=0;
        int c=a/b;
    }

刚开始学代码的时候都会写这个方法,会抛出一个异常:

  

控制台很清楚的告诉我们,被除数不能为0.但是如果我们想自己获取这个异常,然后做些操作呢?比如说 如果这个方法体有问题,我就做一个输出。

    public void methodTry() {
        try {
            int a=10;
            int b=0;
            int c=a/b;
            System.out.println(c);
        } catch (Exception e) {
            System.out.println("这个方法体有问题:"+e.getMessage());
        }
        
    }

这个时候就用到了try-catch,手动的捕获这个异常,然后进行我们需要的操作。毕竟异常分很多种,并不是所有的异常都是我们不需要的。比如说对用户登录来说,登录成功 登录失败两种结果,登录失败又分为重复登录,账号密码不匹配等。我们可以把这些失败全都写成Exception。当成功的时候就直接返回,失败的时候抛出异常,这个可比我们写好多返回值简单多了。

接着说try-catch

  

我们手动的捕获了这个异常。上面的代码告诉我们,当try-catch块中有异常时,异常后面的代码是不会执行的。try-catch还有什么好处?回滚。

3:throw

    public static void main(String[] args) {
        Main main = new Main();
        main.methodThrow();
    }



    public void methodThrow() {
        throw new Exception("这里有异常");
    }

其实当我简单的抛出个异常的时候,throw new Exception()这里会报错,现在看一个报错信息:

  

显示让我们选择是throws 还是try-catch。

我们写好的throw是什么意思呢? 其实跟a/0是一个意思,都是抛出一个异常,只不过一个是jdk已经定义好的异常,被除数不能为0.一个是我们手动抛出的异常。

先用try-catch试试看

  

    public void methodThrow() {
        try {
            throw new Exception("这里有异常");
        } catch (Exception e) {
            System.out.println("MethodThrow:"+e.getMessage());
        }
    }

  

重点在于手动抛出异常后,我们要在catch中进行处理,在catch中写我们的部门逻辑代码。

4:throws

刚才我们选择的是try-catch,现在选择throws

    public static void main(String[] args) throws Exception {
        Main main = new Main();
        main.methodThrow();
    }

    public void methodThrow() throws Exception {
        throw new Exception("这里有异常");
    }

方法methodThrow throws Exception之后,他的父类就面临着两种情况,要么try-catch 要么throws这个异常。这种情况跟methodThrow中手动抛出异常遇到的问题是一样的。

看来可以这么理解:

  throw是手动抛出异常,跟 被除数不能为0 数组下标越界等异常一样,都是异常。

  try-catch是在catch中手动捕获异常,然后进行一些操作。比如说输出异常信息,打印错误日志等。

  throws是往上级抛出异常,我的方法methodThrow有异常,但是在这个方法中我不进行处理了,让上级进行处理吧。然后就跑到main函数那去了。对main函数来说,可以throws让系统进行处理,也可以自己处理这个异常啊。main.methodThrow()和a/0 、throw new Execption()没什么区别,都是有异常。

其实可以整体的写:

    public static void main(String[] args){
        Main main = new Main();
        try {
            main.methodThrow();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
    }

    public void methodThrow() throws Exception {
        throw new Exception("这里有异常");
    }

方法中的异常,到main函数中再进行处理。

 

posted @ 2016-06-05 11:27  假寐的我  阅读(14717)  评论(0编辑  收藏  举报